diff --git a/sys/dev/virtual/vmware/shared/vm_device_version.h b/sys/dev/virtual/vmware/shared/vm_device_version.h
index 4398bf7..6a66422 100644
--- a/sys/dev/virtual/vmware/shared/vm_device_version.h
+++ b/sys/dev/virtual/vmware/shared/vm_device_version.h
@@ -32,7 +32,8 @@
 #define VM_DEVICE_VERSION_H
 
 #define INCLUDE_ALLOW_USERLEVEL
-
+#define INCLUDE_ALLOW_DISTRIBUTE
+#define INCLUDE_ALLOW_VMKDRIVERS
 #define INCLUDE_ALLOW_MODULE
 #define INCLUDE_ALLOW_VMKERNEL
 #define INCLUDE_ALLOW_VMCORE
@@ -67,6 +68,7 @@
 #define PCI_VENDOR_ID_VMWARE                    0x15AD
 #define PCI_DEVICE_ID_VMWARE_SVGA2              0x0405
 #define PCI_DEVICE_ID_VMWARE_SVGA               0x0710
+#define PCI_DEVICE_ID_VMWARE_VGA                0x0711
 #define PCI_DEVICE_ID_VMWARE_NET                0x0720
 #define PCI_DEVICE_ID_VMWARE_SCSI               0x0730
 #define PCI_DEVICE_ID_VMWARE_VMCI               0x0740
@@ -75,7 +77,8 @@
 #define PCI_DEVICE_ID_VMWARE_82546EB            0x0760 /* dual port   */
 #define PCI_DEVICE_ID_VMWARE_EHCI               0x0770
 #define PCI_DEVICE_ID_VMWARE_UHCI               0x0774
-#define PCI_DEVICE_ID_VMWARE_XHCI               0x0778
+#define PCI_DEVICE_ID_VMWARE_XHCI_0096          0x0778
+#define PCI_DEVICE_ID_VMWARE_XHCI_0100          0x0779
 #define PCI_DEVICE_ID_VMWARE_1394               0x0780
 #define PCI_DEVICE_ID_VMWARE_BRIDGE             0x0790
 #define PCI_DEVICE_ID_VMWARE_ROOTPORT           0x07A0
@@ -83,6 +86,7 @@
 #define PCI_DEVICE_ID_VMWARE_VMXWIFI            0x07B8
 #define PCI_DEVICE_ID_VMWARE_PVSCSI             0x07C0
 #define PCI_DEVICE_ID_VMWARE_82574              0x07D0
+#define PCI_DEVICE_ID_VMWARE_AHCI               0x07E0
 #define PCI_DEVICE_ID_VMWARE_HDAUDIO_CODEC      0x1975
 #define PCI_DEVICE_ID_VMWARE_HDAUDIO_CONTROLLER 0x1977
 
@@ -97,6 +101,8 @@
 #define PCI_DEVICE_VMI_INTERFACE        0x00
 #define PCI_DEVICE_VMI_REVISION         0x01
 
+#define PCI_DEVICE_ID_VMWARE_DUMMY      0x0809
+
 /* From linux/pci_ids.h:
  *   AMD Lance Ethernet controller
  *   BusLogic SCSI controller
@@ -117,6 +123,7 @@
  *    Intel 82545EM (e1000, server adapter, single port)
  *    Intel 82546EB (e1000, server adapter, dual port)
  *    Intel HECI (as embedded in ich9m)
+ *    Intel XHCI (as embedded in PANTHERPOINT)
  */
 #define PCI_VENDOR_ID_INTEL             0x8086
 #define PCI_DEVICE_ID_INTEL_82439TX     0x7100
@@ -132,6 +139,7 @@
 #define PCI_DEVICE_ID_INTEL_82574       0x10d3
 #define PCI_DEVICE_ID_INTEL_82574_APPLE 0x10f6
 #define PCI_DEVICE_ID_INTEL_HECI        0x2a74
+#define PCI_DEVICE_ID_INTEL_PANTHERPOINT_XHCI 0x1e31
 
 #define E1000E_PCI_DEVICE_ID_CONFIG_STR "e1000e.pci.deviceID"
 #define E1000E_PCI_SUB_VENDOR_ID_CONFIG_STR "e1000e.pci.subVendorID"
@@ -161,6 +169,11 @@
 #define PCI_REVISION_NEC_UPD720200      0x03
 #define PCI_FIRMWARE_NEC_UPD720200      0x3015
 
+#define SATA_ID_SERIAL_STR "00000000000000000001"  /* Must be 20 Bytes */
+#define SATA_ID_FIRMWARE_STR  "00000001"    /* Must be 8 Bytes */
+
+#define AHCI_ATA_MODEL_STR PRODUCT_GENERIC_NAME " Virtual SATA Hard Drive"
+#define AHCI_ATAPI_MODEL_STR PRODUCT_GENERIC_NAME " Virtual SATA CDRW Drive"
 
 /************* Strings for IDE Identity Fields **************************/
 #define VIDE_ID_SERIAL_STR	"00000000000000000001"	/* Must be 20 Bytes */
@@ -189,6 +202,13 @@
 #define SCSI_MAX_CONTROLLERS	 4	  // Need more than 1 for MSCS clustering
 #define	SCSI_MAX_DEVICES	 16	  // BT-958 emulates only 16
 #define PVSCSI_MAX_DEVICES       255      // 255 (including the controller)
+
+/************* SATA implementation limits ********************************/
+#define SATA_MAX_CONTROLLERS   4
+#define SATA_MAX_DEVICES       30
+#define AHCI_MIN_PORTS         1
+#define AHCI_MAX_PORTS SATA_MAX_DEVICES
+
 /*
  * VSCSI_BV_INTS is the number of uint32's needed for a bit vector
  * to cover all scsi devices per target.
@@ -196,7 +216,15 @@
 #define VSCSI_BV_INTS            CEILING(PVSCSI_MAX_DEVICES, 8 * sizeof (uint32))
 #define SCSI_IDE_CHANNEL         SCSI_MAX_CONTROLLERS
 #define SCSI_IDE_HOSTED_CHANNEL  (SCSI_MAX_CONTROLLERS + 1)
-#define SCSI_MAX_CHANNELS        (SCSI_MAX_CONTROLLERS + 2)
+#define SCSI_SATA_CHANNEL_FIRST  (SCSI_IDE_HOSTED_CHANNEL + 1)
+#define SCSI_MAX_CHANNELS        (SCSI_SATA_CHANNEL_FIRST + SATA_MAX_CONTROLLERS)
+
+/************* SCSI-SATA channel IDs********************************/
+#define SATA_ID_TO_SCSI_ID(sataId)    \
+   (SCSI_SATA_CHANNEL_FIRST + (sataId))
+
+#define SCSI_ID_TO_SATA_ID(scsiId)    \
+   ((scsiId) - SCSI_SATA_CHANNEL_FIRST)
 
 /************* Strings for the VESA BIOS Identity Fields *****************/
 #define VBE_OEM_STRING COMPANY_NAME " SVGA"
@@ -213,7 +241,10 @@
 #define MAX_FLOPPY_DRIVES      2
 
 /************* PCI Passthrough implementation limits ********************/
-#define MAX_PCI_PASSTHRU_DEVICES 6
+#define MAX_PCI_PASSTHRU_DEVICES 16
+
+/************* Test device implementation limits ********************/
+#define MAX_PCI_TEST_DEVICES 16
 
 /************* USB implementation limits ********************************/
 #define MAX_USB_DEVICES_PER_HOST_CONTROLLER 127
diff --git a/sys/dev/virtual/vmware/shared/x86cpuid.h b/sys/dev/virtual/vmware/shared/x86cpuid.h
index 6f534e8..2658f84 100644
--- a/sys/dev/virtual/vmware/shared/x86cpuid.h
+++ b/sys/dev/virtual/vmware/shared/x86cpuid.h
@@ -1,30 +1,18 @@
 /*********************************************************
- * Copyright (C) 1998-2008 VMware, Inc. All rights reserved.
+ * Copyright (C) 1998-2012 VMware, Inc. All rights reserved.
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation version 2 and no later version.
  *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. Neither the name of VMware Inc. nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission of VMware Inc.
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
  *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
  *
  *********************************************************/
 
@@ -47,6 +35,7 @@
 #include "vm_basic_types.h"
 #include "community_source.h"
 #include "x86vendor.h"
+#include "vm_assert.h"
 
 /*
  * The linux kernel's ptrace.h stupidly defines the bare
@@ -101,7 +90,7 @@ CPUIDQuery;
 /*
  * CPUID levels the monitor caches and ones that are not cached, but
  * have fields defined below (short name and actual value).
- *
+ * 
  * The first parameter defines whether the level has its default masks
  * generated from the values in this file.  Any level which is marked
  * as FALSE here *must* have all monitor support types set to NA.  A
@@ -113,8 +102,15 @@ CPUIDQuery;
    CPUIDLEVEL(TRUE,  1,  1)                     \
    CPUIDLEVEL(FALSE, 5,  5)                     \
    CPUIDLEVEL(TRUE,  7,  7)                     \
+   CPUIDLEVEL(FALSE, A,  0xA)                   \
    CPUIDLEVEL(TRUE,  D,  0xD)                   \
    CPUIDLEVEL(FALSE,400, 0x40000000)            \
+   CPUIDLEVEL(FALSE,401, 0x40000001)            \
+   CPUIDLEVEL(FALSE,402, 0x40000002)            \
+   CPUIDLEVEL(FALSE,403, 0x40000003)            \
+   CPUIDLEVEL(FALSE,404, 0x40000004)            \
+   CPUIDLEVEL(FALSE,405, 0x40000005)            \
+   CPUIDLEVEL(FALSE,406, 0x40000006)            \
    CPUIDLEVEL(FALSE,410, 0x40000010)            \
    CPUIDLEVEL(FALSE, 80, 0x80000000)            \
    CPUIDLEVEL(TRUE,  81, 0x80000001)            \
@@ -125,7 +121,6 @@ CPUIDQuery;
 #define CPUID_UNCACHED_LEVELS                   \
    CPUIDLEVEL(FALSE, 4, 4)                      \
    CPUIDLEVEL(FALSE, 6, 6)                      \
-   CPUIDLEVEL(FALSE, A, 0xA)                    \
    CPUIDLEVEL(FALSE, B, 0xB)                    \
    CPUIDLEVEL(FALSE, 85, 0x80000005)            \
    CPUIDLEVEL(FALSE, 86, 0x80000006)            \
@@ -148,8 +143,20 @@ typedef enum {
    CPUID_NUM_CACHED_LEVELS
 } CpuidCachedLevel;
 
+/* Enum to translate between shorthand name and actual CPUID level value. */
+enum {
+#define CPUIDLEVEL(t, s, v) CPUID_LEVEL_VAL_##s = v,
+   CPUID_ALL_LEVELS
+#undef CPUIDLEVEL
+};
+
 
-/* SVM CPUID feature leaf */
+/* Named feature leaves */
+#define CPUID_FEATURE_INFORMATION  0x01
+#define CPUID_PROCESSOR_TOPOLOGY   4
+#define CPUID_MWAIT_FEATURES       5
+#define CPUID_XSAVE_FEATURES       0xd
+#define CPUID_HYPERVISOR_LEVEL_0   0x40000000
 #define CPUID_SVM_FEATURES         0x8000000a
 
 
@@ -186,7 +193,7 @@ typedef enum {
 #define CPUID_VIA_VENDOR_STRING_FIXED   "CentaurHauls"
 
 /*
- * FIELDDEF can be defined to process the CPUID information provided
+ * FIELD can be defined to process the CPUID information provided
  * in the following CPUID_FIELD_DATA macro.  The first parameter is
  * the CPUID level of the feature (must be defined in
  * CPUID_ALL_LEVELS, above.  The second parameter is the CPUID result
@@ -205,12 +212,9 @@ typedef enum {
  * being used by usermode code (TRUE), or just CPL0 kernel code
  * (FALSE).
  *
- * FIELDDEFA takes a ninth parameter: the name used when generating
- * accessor functions in lib/public/cpuidInfoFuncs.h.
- *
- * FLAGDEF/FLAGDEFA is defined identically to fields, but their
- * accessors are more appropriate for 1-bit flags, and compile-time
- * asserts enforce that the size is 1 bit wide.
+ * FLAG is defined identically to FIELD, but its accessors are more
+ * appropriate for 1-bit flags, and compile-time asserts enforce that
+ * the size is 1 bit wide.
  */
 
 
